// UsbHidDemoCodeDlg.cpp : ̧
//
////////////////////////////////////////////////////////////////////////////////
//  ̎۸тAtUsbHidײ؂̊֐sg܂B
//  ײ؊֐^AtUsbHid.ḩق̍Ō̕œ܂B
//
////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "UsbHidDemoCode.h"
#include "UsbHidDemoCodeDlg.h"
#include <winuser.h>
#include <windows.h>
#include <dbt.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ATMEL HID USBݸٰ
#include "AtUsbHid.h"

#define DEFAULT_VID 0x03EB
#define DEFAULT_PID 0x2013

/*---------------------------------------------------------------------------

֐: handleError

ړI: ֐ĂяoɂĈُ킪Ԃ鎞ɌĂт܂B

Ұ: DWORD errorCode - ُ\ُ필

Ԃ:

:

---------------------------------------------------------------------------*/
void handleError(DWORD errorCode)
{
	switch(errorCode)
	{
	case ERROR_MOD_NOT_FOUND:
		AfxMessageBox( "Could not find Atmel USB HID DLL: AtUsbHid.dll\nPlease update the PATH variable.\n", MB_ICONSTOP,0);
		exit(-1);
		break;

	case ERROR_USB_DEVICE_NOT_FOUND:
		OutputDebugString("Error: Could not open the device.\n");
		break;

	case ERROR_USB_DEVICE_NO_CAPABILITIES:
		OutputDebugString("Error: Could not get USB device capabilities.\n");
		break;

	case ERROR_WRITE_FAULT:
		OutputDebugString("Error: Could not write.\n");
		break;

	case ERROR_READ_FAULT:
		OutputDebugString("Error: Could not read.\n");
		break;

	default:
		OutputDebugString("Error: Unknown error code.\n");
	}
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg Aboutpɑ΂Ďgp޲۸

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// ޲۸ ް
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizardz֐
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDVx
	//}}AFX_VIRTUAL

// 
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUsbHidDemoCodeDlg ޲۸

CUsbHidDemoCodeDlg::CUsbHidDemoCodeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUsbHidDemoCodeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUsbHidDemoCodeDlg)
	m_PID = _T("2013");
	m_VID = _T("03EB");
	//}}AFX_DATA_INIT
	// Win32LoadIcon͂̌DestroyIconKvȂƂɒӂĂB
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

}

void CUsbHidDemoCodeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUsbHidDemoCodeDlg)
	DDX_Control(pDX, IDC_FW_UPGRADE, m_FwUpgrade);
	DDX_Control(pDX, IDC_LIST, m_RecievedData);
	DDX_Control(pDX, IDC_STATUS_TEXT, m_Status);
	DDX_Control(pDX, IDC_LED4, m_Led4);
	DDX_Control(pDX, IDC_LED3, m_Led3);
	DDX_Control(pDX, IDC_LED2, m_Led2);
	DDX_Control(pDX, IDC_LED1, m_Led1);
	DDX_Text(pDX, IDC_PID, m_PID);
	DDV_MaxChars(pDX, m_PID, 4);
	DDX_Text(pDX, IDC_VID, m_VID);
	DDV_MaxChars(pDX, m_VID, 4);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUsbHidDemoCodeDlg, CDialog)
	//{{AFX_MSG_MAP(CUsbHidDemoCodeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LED1, OnLed1)
	ON_BN_CLICKED(IDC_LED2, OnLed2)
	ON_BN_CLICKED(IDC_LED3, OnLed3)
	ON_BN_CLICKED(IDC_LED4, OnLed4)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_PW_UPGRADE, OnFwUpgrade)
	ON_BN_CLICKED(IDC_BUTTON_VID_PID, OnButtonVidPid)
	//}}AFX_MSG_MAP
	ON_WM_DEVICECHANGE()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUsbHidDemoCodeDlgүޏ

BOOL CUsbHidDemoCodeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ƭ"About..."ƭڂǉ

	// IDM_ABOUTBOXͼіߔ͈͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ޲۸ޗp݂ݒBgg݂͉p̎峨޳޲۸ނłȂɎI
	// ɂs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ȱݐݒ
	SetIcon(m_hIcon, FALSE);		// ȱݐݒ

	// VIDPIDݒ
	Vid  = DEFAULT_VID;	
	Pid  = DEFAULT_PID;

	// ڑ܂őSĂLEDt֎~
	DisableLedButton();

	// AtUsbHidײ؂𖾎Iɐݒ
	hLib = LoadLibrary(AT_USB_HID_DLL);
    if (hLib == NULL)
    {
        handleError(GetLastError());
        return 0;
    }

    // USB HIDײ؊֐ڽ擾
    if (loadFuncPointers(hLib)==NULL) {
		AfxMessageBox( "Could not get USB HID library functions addresses",MB_ICONSTOP,0);
        return 0;
	}

	// uڑs
    ConnectDevice();

	DYNCALL(hidRegisterDeviceNotification)((m_hWnd));

	return TRUE;  // œ_۰قɐݒ肵ȂTRUEԂB
}

void CUsbHidDemoCodeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Ȃ޲۸ނɍŏtǉꍇA݂`悷邽߂ɉ̺ނKv
// B޷/ޭlgpMFCpɂāA͘gg݂ɂĎI
// s܂B

void CUsbHidDemoCodeDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // hp޲ ÷

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// ײċ`
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ݕ`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// gp҂ŏꂽ޳ׯނԂ̕\ɑ΂Ķق𓾂邽߂ɼт
// Ăт܂B
HCURSOR CUsbHidDemoCodeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/*---------------------------------------------------------------------------

֐: OnLed1

ړI: LED1tꂽꍇLED1؂ւ

Ұ:

Ԃ:

:

---------------------------------------------------------------------------*/
void CUsbHidDemoCodeDlg::OnLed1()
{
	if(Led1 == false) {
		Led1 = true;
		m_Led1.SetWindowText(_T("LED 1 ON"));
		DYNCALL(writeData)((UCHAR *)"11");
	}
	else {
		Led1 = false;
		m_Led1.SetWindowText(_T("LED 1 OFF"));
		DYNCALL(writeData)((UCHAR *)"01");
	}
}

/*---------------------------------------------------------------------------

֐: OnLed2

ړI: LED2tꂽꍇLED2؂ւ

Ұ:

Ԃ:

:

---------------------------------------------------------------------------*/
void CUsbHidDemoCodeDlg::OnLed2()
{
	if(Led2 == false) {
		Led2 = true;
		m_Led2.SetWindowText(_T("LED 2 ON"));
		DYNCALL(writeData)((UCHAR *)"12");
	}
	else {
		Led2 = false;
		m_Led2.SetWindowText(_T("LED 2 OFF"));
		DYNCALL(writeData)((UCHAR *)"02");
	}
}

/*---------------------------------------------------------------------------

֐: OnLed3

ړI: LED3tꂽꍇLED3؂ւ

Ұ:

Ԃ:

:

---------------------------------------------------------------------------*/
void CUsbHidDemoCodeDlg::OnLed3()
{
	if(Led3 == false) {
		Led3 = true;
		m_Led3.SetWindowText(_T("LED 3 ON"));
		DYNCALL(writeData)((UCHAR *)"13");
	}
	else {
		Led3 = false;
		m_Led3.SetWindowText(_T("LED 3 OFF"));
		DYNCALL(writeData)((UCHAR *)"03");
	}
}

/*---------------------------------------------------------------------------

֐: OnLed4

ړI: LED4tꂽꍇLED4؂ւ

ړI:

Ԃ:

:

---------------------------------------------------------------------------*/
void CUsbHidDemoCodeDlg::OnLed4()
{
	if(Led4 == false) {
		Led4 = true;
		m_Led4.SetWindowText(_T("LED 4 ON"));
		DYNCALL(writeData)((UCHAR*)"14");
	}
	else {
		Led4 = false;
		m_Led4.SetWindowText(_T("LED 4 OFF"));
		DYNCALL(writeData)((UCHAR*)"04");
	}
}

/*---------------------------------------------------------------------------

֐: DisableLedButton

ړI: SĂLEDt֎~
		̧ѳXVt֎~
		LEDݕύX
		݂̏Ԃؒf(Diconnected)ɕύX
		ǂݍ݋@\v~

Ұ:

Ԃ:

:

---------------------------------------------------------------------------*/
void CUsbHidDemoCodeDlg::DisableLedButton()
{
	// SLEDOFFɐݒ
	Led1 = false ;
	Led2 = false ;
	Led3 = false ;
	Led4 = false ;

	// SLED݂֎~
	m_Led1.EnableWindow(false);
	m_Led2.EnableWindow(false);
	m_Led3.EnableWindow(false);
	m_Led4.EnableWindow(false);

	// ̧ѳXV֎~
	m_FwUpgrade.EnableWindow(false);

	// LEDύX
	m_Led1.SetWindowText(_T("LED 1"));
	m_Led2.SetWindowText(_T("LED 2"));
	m_Led3.SetWindowText(_T("LED 3"));
	m_Led4.SetWindowText(_T("LED 4"));

	m_Status.SetWindowText(_T("Disconnected"));

	CDialog::KillTimer(1);

	IsConnected = false ;
}

/*---------------------------------------------------------------------------

֐: ConnectDevice

ړI: ݂VIDPIDpđuڑ
		ڑȂAԂڑ(Connected)ɕύX
		ڑsȂAԂ͐ؒf(disconnected)ɐݒ肳܂B

Ұ:

Ԃ:

:

---------------------------------------------------------------------------*/
void CUsbHidDemoCodeDlg::ConnectDevice()
{
	// XUSBuJB
	if (DYNCALL(findHidDevice)(Vid, Pid)) {
		EnableLedButton();
	}
	else {
		// ڑĂȂ΁ALEDtɱł܂B
		DisableLedButton();
	}
}

/*---------------------------------------------------------------------------

֐: EnableLedButton

ړI: SĂLEDt
		̧ѳXVt
		SLED̏ԂOFFɐݒ
		uLEDOFF𑗏o
		ǂݍ݋@\vݒ

Ұ:

Ԃ:

:

---------------------------------------------------------------------------*/
void CUsbHidDemoCodeDlg::EnableLedButton()
{
	CString inReport;
	CString outReport;
	CString featureReport;

	// SLEDt
	m_Led1.EnableWindow(true);
	m_Led2.EnableWindow(true);
	m_Led3.EnableWindow(true);
	m_Led4.EnableWindow(true);

	// ̧ѳXV
	m_FwUpgrade.EnableWindow(true);

	// LEDύX
	m_Led1.SetWindowText(_T("LED 1 OFF"));
	m_Led2.SetWindowText(_T("LED 2 OFF"));
	m_Led3.SetWindowText(_T("LED 3 OFF"));
	m_Led4.SetWindowText(_T("LED 4 OFF"));

	// SLED̋֎~mɂB
	DYNCALL(writeData)((UCHAR*)"01");
	DYNCALL(writeData)((UCHAR*)"02");
	DYNCALL(writeData)((UCHAR*)"03");
	DYNCALL(writeData)((UCHAR*)"04");

	inReport.Format(     "%s: %dByte"," In",DYNCALL(getInputReportLength()));
	outReport.Format(    "%s: %dByte"," Out",DYNCALL(getOutputReportLength()));
	featureReport.Format("%s: %dByte"," Feature",DYNCALL(getFeatureReportLength()));

	CString text = "Connected\t\t"+inReport+","+outReport+","+featureReport;

	m_Status.SetWindowText(text);

	SetTimer(1,50,0);

	IsConnected = true ;
}

/*---------------------------------------------------------------------------

֐: OnDeviceChange

ړI: ̊֐ON_WM_DEVICECHANGE()pđû߂ɏԕύXɌĂт܂B
		֐͂̉X̑ȕԂύX𒲂ׂ܂B
		2̏dvȎۂ̌`܂B
			DBT_DEVICEARRIVAL : ̏ꍇA݂VIDPIDpđu̐ڑ
				݂܂B
			DBT_DEVICEREMOVECOMPLETE : X̑uؒfꂽꍇAcloseDevice()
				gpđu𐳂܂B

		OnDeviceChangeʂ̑uɂČĂ΂ꂽꍇA邱Ƃ܂B

Ұ:	UINT nEventType	: ID
		DWORD dwData	: ۂƒgް

Ԃ:

:

---------------------------------------------------------------------------*/
BOOL CUsbHidDemoCodeDlg::OnDeviceChange(UINT nEventType, DWORD dwData)
{
	int isOurDevice;
	switch(nEventType)
		{
			case DBT_DEVICEARRIVAL :
				isOurDevice=DYNCALL(isMyDeviceNotification(dwData));
				if(isOurDevice&&IsConnected) {
					OutputDebugString(">>> Our Device Already Connected.\n");
				}
				else {
					// Ԃؒf(Disconnected)̏ꍇɂڑ
					OutputDebugString(">>> A device has been inserted and is now available.\n");
					ConnectDevice();
				}
				break;

			case DBT_DEVICEREMOVECOMPLETE :
				isOurDevice=DYNCALL(isMyDeviceNotification(dwData));
				if(IsConnected&&isOurDevice) {
					// xڑB
					DisableLedButton();
					DYNCALL(closeDevice());
					OutputDebugString(">>> A device has been removed.\n");
				}
				break;

			default :
				OutputDebugString(">>> OnDeviceChange : default\n");
				break;
		}
	return TRUE;
}

/*---------------------------------------------------------------------------

֐: AddRecievedData

ړI: ̊֐m_RecievedData CListɐVүނǉĈꗗ傫
	  邽߂ɍłÂ100үނ폜܂B

Ұ: CString NewData - CListŕ\V

Ԃ:

:

---------------------------------------------------------------------------*/
void CUsbHidDemoCodeDlg::AddRecievedData(CString NewData)
{
	m_RecievedData.AddString( NewData );

	// 󂯎Ō100үނ\
	if(m_RecievedData.GetCount()>100) {
		m_RecievedData.DeleteString(0);
	}

	// ̫Ō̗vfɐݒ
	int nCount = m_RecievedData.GetCount();
	if (nCount > 0) m_RecievedData.SetCurSel(nCount-1);
}

/*---------------------------------------------------------------------------

֐: OnTimer

ړI: ̊֐͐Vް󂯎ꂽ𒲂ׂĂяo܂B
		Ȃ΁AɏՕAddRecievedDatapĕ\܂B
		̊֐p̌v͐ڑꂽꍇCDialog::KillTimer(1)֐gp
		Ď~߂Ȃ΂Ȃ܂B
		uڑĂꍇAvSetTimer(1,50,0)gpĐݒ肳
		΂Ȃ܂B

Ұ: nIDEvent - v펯ʎq

Ԃ:

:

---------------------------------------------------------------------------*/
void CUsbHidDemoCodeDlg::OnTimer(UINT nIDEvent)
{
	UCHAR sbuffer[255];
	if(DYNCALL(readData(sbuffer))!=0) {
		if(sbuffer[0]==1) {
			AddRecievedData("Button as been pressed");
		}
		else {
			AddRecievedData("Button as been released");
		}
		// \ް΁A
	}
	CDialog::OnTimer(nIDEvent);
}

/*---------------------------------------------------------------------------

֐: OnFwUpgrade

ړI: ̧ѳXVtꂽɌĂԁB
		̊֐startBootLoaderpđu̧ѳXVɐݒ肵܂B
		Uް۰ޓ삪ƁAu͐܂B
		V̧ѳݒ肷邽߂FLIPJnȂ΂Ȃ܂B

Ұ:

Ԃ:

:

---------------------------------------------------------------------------*/
void CUsbHidDemoCodeDlg::OnFwUpgrade() 
{
	if(IsConnected) { // X̑utȂA
		UCHAR* outputReport = new UCHAR[DYNCALL(getFeatureReportLength())];

		outputReport[0]=0x55;
		outputReport[1]=0xAA;
		outputReport[2]=0x55;
		outputReport[3]=0xAA;

		if(!DYNCALL(setFeature(outputReport))) {
			// ް۰ޑss
			AfxMessageBox( "Can not start Device in Boot Loader mode", MB_ICONSTOP,0);
		}		
		DisableLedButton();
		DYNCALL(closeDevice()); // SĂقB
	}
}

/*---------------------------------------------------------------------------

֐: OnCancel

ړI: 1̎őuڑĂȂÂ̂ؒf܂B
		phidUnregisterDeviceNotification(m_hWnd)pđuʒm\o^
		O܂B

Ұ:

Ԃ:

:

---------------------------------------------------------------------------*/
void CUsbHidDemoCodeDlg::OnCancel()
{
	if(IsConnected) // X̑utĂȂA
	{
		DYNCALL(closeDevice());	// SقB
		CDialog::KillTimer(1);	// SvB
	}
	DYNCALL(hidUnregisterDeviceNotification(m_hWnd));

	FreeLibrary(hLib);

	CDialog::OnCancel();
}

/*---------------------------------------------------------------------------

֐: OnButtonVidPid

ړI: VIDPID̖tł̸دAIDƐiID͕ҏWޯ玝ėāA
		Vlɕς܂B

Ұ:

Ԃ:

:

---------------------------------------------------------------------------*/
void CUsbHidDemoCodeDlg::OnButtonVidPid()
{
	UpdateData();

	// 16iŕϊs
	char VidToConvert[10];
	char PidToConvert[10];
	char * pEnd;
	long newVid;
	long newPid;

	// VVID擾
	strcpy(VidToConvert,"0x");
	strcat(VidToConvert,m_VID.GetBuffer(m_VID.GetLength()));
	newVid = strtol (VidToConvert,&pEnd,0);
	m_VID.Format("%X",newVid);

	// VPID擾
	strcpy(PidToConvert,"0x");
	strcat(PidToConvert,m_PID.GetBuffer(m_PID.GetLength()));
	newPid = strtol (PidToConvert,&pEnd,0);
	m_PID.Format("%X",newPid);

	// XV
	SetDlgItemText(IDC_VID , m_VID.GetBuffer(m_VID.GetLength()));
	SetDlgItemText(IDC_PID , m_PID.GetBuffer(m_PID.GetLength()));

	if((newVid!=Vid)||(newPid!=Pid)) {
		Vid=newVid;
		Pid=newPid;
		if(IsConnected) {
			// xڑB
			DisableLedButton();
			DYNCALL(closeDevice());
		}
		ConnectDevice();
	}
}
